<!DOCTYPE html>
<html>

<head>
    <title>Message Forum</title>
    <link rel="stylesheet" href="{{ url_for('static', filename='index.css') }}" />
	<link rel="icon" href="favicon.png" type="image/png" />

    <!-- Icons -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Material+Symbols+Outlined:opsz,wght,FILL,GRAD@48,400,0,0" />
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Material+Symbols+Outlined:opsz,wght,FILL,GRAD@48,400,0,0" />
</head>

<body>
    <div id="page">
        <!-- Header contains logout button and username -->
        <header>

            <a href="/logout"><button>Log out<span class="material-symbols-outlined">logout</span></button></a>

            <p id="username_display">Your username</p>

        </header>

        <!-- Main contains messages -->
        <main id="messages">
            <br><br>
        </main>

        <!-- Footer contains inputs -->
        <footer>

            <textarea id="message_area" placeholder="Send a message to everyone..." maxlength="130"></textarea>
            <span id="chars_left"></span>
            <button id="send_button"><span class="material-symbols-outlined">send</span></button>

        </footer>
    </div>
</body>

<script>
    let username = "{{ current_user.id }}"
    let csrf_token = "{{ csrf_token() }}"

    let messages = document.getElementById("messages")
    let usernameDisplay = document.getElementById("username_display")
    let messageArea = document.getElementById("message_area")
    let charsLeftIndicator = document.getElementById("chars_left")

    let highestMessageId = 0;

    const capitalizeString = (string) => string.charAt(0).toUpperCase() + string.slice(1)

    usernameDisplay.innerText = capitalizeString(username)

    charsLeftIndicator.innerText = messageArea.getAttribute("maxlength")
    messageArea.addEventListener("keydown", e => {
        // When pressing enter
        if (e.keyCode == 13) {
            e.preventDefault()
            let message = messageArea.value.trim()

            if (message.length == 0)
                return
            // If using the '/private' command, send a private message
            if (message.substring(0, 8) == '/private') {
                let recipient = message.slice(9).split(" ")[0].toLowerCase()
                let text = message.slice(9).split(" ").splice(1).join(" ")
                if (text.length == 0)
                    return
                sendPrivate(text, recipient)

            } else
                sendMessage(message)

            // Clear the message area
            messageArea.value = ""
        }
    })
    // Event listeners
    messageArea.addEventListener("input", e => {
        let length = messageArea.value.length
        charsLeftIndicator.innerText = messageArea.getAttribute("maxlength") - length
    })
    messages.addEventListener("scroll", e => {
        if (messages.scrollTop == 0.5)
            messages.scrollTo(0, 0)
    })

    // Display a single message
    function displayMessage(message) {
        let itsYourMessage = message.sender == username

        let div = document.createElement('div')
        let p = document.createElement('p')

        div.className = 'message'
        if (itsYourMessage) {
            div.className += ' by_you'
            div.setAttribute('sentto', capitalizeString(message.recipient))
        } else {
            div.className += ' by_others'
            div.setAttribute('sentby', capitalizeString(message.sender))
        }

        if (message.recipient != 'everyone')
            div.className += ' private'

        div.setAttribute('timestamp', message.timestamp.substring(11, 16))
        p.innerText = message.message
        div.appendChild(p)
        messages.prepend(div)
    }

    // Retrieve and display all messages in the database
    async function retrieveAllMessages() {
        let allMessages = await fetch('/messages').then(res => res.json())
        for (message of allMessages) {
            displayMessage(message)

            if (highestMessageId < parseInt(message.message_id)) 
                highestMessageId = parseInt(message.message_id)
        }
    }

    // Retrieve and display a given message from the database
    async function retrieveIdMessage(id) {
        let message = await fetch('/messages/ID?id=' + encodeURIComponent(id)).then(res => res.json())
        displayMessage(message)
    }

    // Send a message to every user
    async function sendMessage(message) {
        fetch(`/new?message=${encodeURIComponent(message)}`, { method: 'post', headers: {'CSRFTOKEN': csrf_token}})
        .then(res => res.json()).then(res => {
            if (res.error == undefined) {
                updateMessages()
            } else {
                alert(res.error)
            }
        }).catch(e => {
            console.log('Error ' + e)
        })
    } 

    // Send a private message to a single user
    async function sendPrivate(message, recipient) {
        fetch(`/new?message=${encodeURIComponent(message)}&recipient=${encodeURIComponent(recipient)}`, { method: 'post', headers: {'CSRFTOKEN': csrf_token}})
        .then(res => res.json()).then(res => {
            if (res.error == undefined) {
                updateMessages()
            } else {
                alert(res.error)
            }
        }).catch(e => {
            console.log('Error ' + e)
        })
    }

    // Checks if there are any new messages in the database, and displays them
    async function updateMessages() {
        let maxMessageId = await fetch('/messages/ID').then(res => res.json()).then(res => parseInt(res.message_id))

        if (highestMessageId != maxMessageId) {
            let currentMessageId = highestMessageId;
            highestMessageId = maxMessageId;
            while (currentMessageId < maxMessageId)
                retrieveIdMessage(++currentMessageId)

        }
    }

    // Retrieve all messages and update messages once every second
    retrieveAllMessages()
    setInterval(updateMessages, 1000)
</script>

</html>